#ifndef ccnb_h
#define ccnb_h


#include "defo.h"      

#include "bodies.h"
#include "krawczyk-newton.h"

#include <future>
#include <thread>


using namespace std;
using namespace capd;




/* ============ *
 *   Globals    *
 * ============ */
extern ofstream outFileSearch;
extern ofstream outFileTest;
extern ofstream outFileFailed;

extern ofstream mathFile;
extern ofstream mathListFile;


extern char zerosFile[30];  // the name for the file where all boxes coinating zeros (i.e. CC) found in the search stage are written - binary file
extern char undecidedFile[30]; // the name for the file where all zeros found in the search stage are written - binary file
extern char zerosTestedFile[30]; // the name for the file where all boxes coinating zeros (i.e. CC) found in the testing stage are written - binary file
extern char foutfMath[30];   // the name of the file for some mathematica data - text file
extern char foutfMathList[30]; // the name of the file for some mathematica data - text file




extern mutex updateCounter_mutex;
extern mutex krawczykSection_mutex;
extern mutex write_mutex;


extern std::atomic<int> cnt;
extern atomic<int> boxCount; // number of checked boxes
extern atomic<long> clusterImprovementCounter;
extern atomic<long> interQuadCounter;
extern atomic<long> aprioriCounter;
extern atomic<long> clusterCounter;
extern atomic<long> distanceCounter;
extern atomic<long> checkZeroCounter;
extern atomic<long> KrawczykFailedCounter;
extern atomic<long> KrawczykZeroCounter;
extern atomic<long> KrawczykNoZeroCounter;
extern atomic<long> methodFailedCounter;
extern atomic<long> methodZeroes;
extern atomic<long> UEqICounter;
extern atomic<long> isoBoxesCount;


extern  int MAX_ITER_NEWTON;
extern int MAX_ASYNC_DEPTH ;

extern MyDouble bias;
extern MyDouble eps;
extern NormalizationMethod normalizationMethod;
extern ZeroSearchType methodUsed;
extern bool equalMasses;
extern bool orderIncreasing;
extern bool fixedOrderOfBodies;


#endif
